  member()

  include('keycodes.clw')
  include('winequ.clw')
  include('gjsAPI.clw', 'Equates')

  include('cmEng.INC')

  map
    include('DDE.CLW')
    include('clib.CLW')
    include('gjsAPI', 'Prototypes')
  end

!|  ------------------------------------------------------------------------------------------------
!|  CompileFile
!|  ~~~~~~~~~~~~~~~~~~
!|  ------------------------------------------------------------------------------------------------
cmCompileClass.Construct    procedure()

  code
  self.cRed &= new(gjsRedClass)
  assert(~(self.cRed &= null))

  self.cCurrentFile &= new(gjsFileClass)
  assert(~(self.cCurrentFile &= null))


cmCompileCLass.Destruct     procedure()

  code
  dispose(self.cRed)
  assert(self.cRed &= null)

  dispose(self.cCurrentFile)
  assert(self.cCurrentFile &= null)


cmCompileCLass.DoCompile    procedure(string sFile, *gResultAttributes gResult, string sRed, string sCW, string sRoot)

lServer                     long
lCount                      long

qFiles                      queue(ff_:Queue), pre(DIR)
                            end

lHoldDate                   long
lHoldTime                   long

bReturn                     byte

DDEErrorMsg                 cstring(300)
DDEErrorNum                 ushort
lErr                        long

bStartFlag                  byte

qRenamedFiles               queue
sOldName                      string(FILE:MaxFilePath)
sNewName                      string(FILE:MaxFilePath)
                            end

lExt                        long

cCopyTo                     gjsFileClass
csCopyTo                    cstring(FILE:MaxFilePath)

  code

  if self.cRed.DoLoadQ(sRed,,sRoot) = 0
    message('An invalid rediretion file has been selected.  Please select a valid option from File/Properties.', 'Error', ICON:Exclamation)
    return(0)
  end

  self.cCurrentFile.Init(sFile)

  if self.bShowResult
    free(qRenamedFiles)
    if self.cRed.DoLoadQ(sRed, clip(self.cCurrentFile.sDrive) & clip(self.cCurrentFile.sDir), sRoot)
      loop; yield
        if self.cRed.GetFinalResult(sFile) = eNoExeFound
          break
        else
          qRenamedFiles.sOldName = self.cRed.sFinalPath
          cCopyTo.Init(self.cRed.sFinalPath)
          lExt = 0
          loop; yield
            csCopyTo = clip(cCopyTo.sDrive) & clip(cCopyTo.sDir) & clip(cCopyTo.sName) & '.' & format(lExt, @n03)
            if access(csCopyTo, 0)
              lExt += 1
              break
            end
            lExt += 1
          end
          qRenamedFiles.sNewName = csCopyTo
          copy(clip(qRenamedFiles.sOldName), clip(qRenamedFiles.sNewName))
          if errorcode()
            assert(~errorcode())
          else
            remove(clip(qRenamedFiles.sOldName))
            assert(~errorcode())
          end
          add(qRenamedFiles)
        end
      end
    end
  end

  do StartCompile

  if lCount > 50
    return(0)
  end

  accept
    case event()
    of EVENT:Timer
      if bStartFlag
        do CheckEndOfCompile
        if bReturn
          break
        end
      end
    end

    case field()
    of self.ControlStop
      case event()
      of EVENT:Accepted
        bReturn = 0
        break
      end

    of self.ControlSkip
      case event()
      of EVENT:Accepted
        bReturn = 2
        break
      end
    end
  end

  ddeclose(lServer)

  if self.bShowResult
    loop; yield
      get(qRenamedFiles, 1)
      if errorcode()
        break
      end
      csCopyTo = clip(qRenamedFiles.sOldName)
      if access(csCopyTo, 0)
        copy(clip(qRenamedFiles.sNewName), clip(qRenamedFiles.sOldName))
        assert(~errorcode())
        remove(clip(qRenamedFiles.sNewName))
        assert(~errorcode())
      else
        remove(clip(qRenamedFiles.sNewName))
        if lower(csCopyto[len(csCopyto) - 3 : len(csCopyto)]) ~= '.lib'
          bReturn = 3
        end
      end
      delete(qRenamedFiles)
    end
  else
    bReturn = 4
  end

  return(bReturn)

StartCompile                routine

  data

gResult                     group(ResultGroup)
                            end

  code
  if upper(self.cCurrentFile.sExt) = '.APP'
    free(qFiles)
    directory(qFiles, self.cCurrentFile.sPath, ff_:Normal)
    get(qFiles, 1)
    if errorcode()
      lHoldDate = 0
      lHoldTime = 0
    else
      lHoldDate = DIR:Date
      lHoldTime = DIR:Time
    end
  else
    sDos = clip(self.cCurrentFile.sDrive) & CLIP(self.cCurrentFile.sDir) & 'CM2$$$$$.PRJ'
    create(fDos)
    assert(~errorcode())
    open(fDos)
    assert(~errorcode())
    fDos.Rec.sLine = '#file delete ' & clip(sDos) & '<13><10>'
    add(fDos)
    assert(~errorcode())
    close(fDos)
    assert(~errorcode())
  end

  do RunClarion
  setpath(clip(self.cCurrentFile.sDrive) & clip(self.cCurrentFile.sDir))

  if upper(self.cCurrentFile.sExt) ~= '.APP'
    ddeexecute(lServer,'[LoadApplication(' & clip(self.cCurrentFile.sPath) & ')]')
  end

  do CheckDDEError

  ddeexecute(lServer,'[ExecuteProject(' & clip(self.cCurrentFile.sPath) & ')]')
  
  do CheckDDEError

  bStartFlag = 1

CheckEndOfCompile           routine
  if upper(self.cCurrentFile.sExt) = '.APP'
    free(qFiles)
    directory(qFiles, clip(self.cCurrentFile.sPath), ff_:Normal)
    get(qFiles, 1)
    if lHoldDate < DIR:Date or |
       lHoldTime < DIR:Time
      bReturn = 1
    end
  else
    ddeexecute(lServer,'[ExecuteProject(' & clip(self.cCurrentFile.sDrive) & clip(self.cCurrentFile.sDir) & 'CM2$$$$$.PRJ' & ')]')
    free(qFiles)
    directory(qFiles, clip(self.cCurrentFile.sDrive) & clip(self.cCurrentFile.sDir) & 'CM2$$$$$.PRJ', ff_:Normal)
    get(qFiles, 1)
    if errorcode()
      bReturn = 1
    end
  end

RunClarion                  routine
  lCount = 0
  loop; yield
    lServer = ddeclient('ClarionWin')
    if lServer = 0
      run(clip(sCW) & ' /n')
    else
      break
    end
    lCount += 1
    if lCount > 50
      message('Unable to start Clarion for Windows', 'ERROR', ICON:Exclamation)
      bReturn = 0
    end
  end

CheckDDEError               routine

  DDEErrorMsg = ''
  lErr = errorcode()
  if lErr > 600        ! ERRORCODE is DDE related
    if lErr = 603        ! DDEExecute Failed
      dderead(lServer, DDE:manual, 'GetErrorNum', DDEErrorNum)
      dderead(lServer, DDE:manual, 'GetErrorMsg', DDEErrorMsg)
      if DDEErrorNum ~= 10
        beep
        message('Error ' & DDEErrorNum & ' : ' & clip(DDEErrorMsg))
        bReturn = 0
      else
        assert(False)
      end
    end
  end

