  member

  include('CM2.INC')
  include('keycodes.clw')
  include('winequ.clw')
  include('gjsAPI.clw', 'Equates')
  include('gjsWarn.INC')

  include('cmMain.INC')

  map
    include('gjsAPI', 'Prototypes')
    include('clib.clw')
  end

cmMainClass.Construct       procedure()

  code
  self.qProgs &= new(ProgsQueue)
  assert(~(self.qProgs &= null))

  self.cComFile &= new(gjsFileClass)
  assert(~(self.cComFile &= null))

  self.cAbout &= new(gjsAboutClass)
  assert(~(self.cAbout &= null))

  self.cCompile &= new(cmCompileClass)
  assert(~(self.cCompile &= null))

cmMainClass.Destruct        procedure()

  code
  free(self.qProgs)
  assert(records(self.qProgs) = 0)
  dispose(self.qProgs)
  assert(self.qProgs &= null)

  dispose(self.cComFile)
  assert(self.cComFile &= null)

  dispose(self.cAbout)
  assert(self.cAbout &= null)

  dispose(self.cCompile)
  assert(self.cCompile &= null)

cmMainClass.Display         procedure()

window WINDOW(eTitle),AT(,,154,119),FONT('MS Sans Serif',8,,FONT:regular),IMM,ICON('a.ICO'),TIMER(10), |
         SYSTEM,GRAY,MAX,RESIZE
       MENUBAR
         MENU('&File'),USE(?MenuFile)
           ITEM('&New'),USE(?FileNew)
           ITEM('&Open...'),USE(?FileOpen)
           ITEM('&Import .CCL file'),USE(?FileImport),DISABLE
           ITEM,SEPARATOR
           ITEM('&Close'),USE(?FileClose),DISABLE
           ITEM('&Properties'),USE(?FileProperties),DISABLE
           ITEM,SEPARATOR
           ITEM('&1 '),USE(?FilePrevious1)
           ITEM('&2 '),USE(?FilePrevious2)
           ITEM('&3 '),USE(?FilePrevious3)
           ITEM('&4 '),USE(?FilePrevious4)
           ITEM,SEPARATOR
           ITEM('E&xit'),USE(?FileExit),LAST
         END
         MENU('&Edit'),USE(?MenuEdit),DISABLE
           ITEM('&Insert<9>InsertKey'),USE(?EditIns),KEY(InsertKey)
           ITEM('&Delete<9>DeleteKey'),USE(?EditDel),KEY(DeleteKey)
           ITEM,SEPARATOR
           ITEM('Move &Up'),USE(?EditMoveUp)
           ITEM('Move D&own'),USE(?EditMoveDown)
         END
         MENU('&Compile'),USE(?MenuCompile),DISABLE
           ITEM('&Selected'),USE(?CompileOne)
           ITEM('&All'),USE(?CompileAll)
         END
         MENU('&Options'),USE(?MenuOptions)
           ITEM('&Display Toolbar'),USE(self.bTool,, ?bTool),CHECK
           ITEM('Always on &Top'),USE(self.bTop,, ?bTop),CHECK
           ITEM('Display &Result'),USE(self.bResult,, ?bResult),CHECK
           ITEM('&Sounds'),USE(?OptionSound)
           ITEM,SEPARATOR
           ITEM('&Reset INI file'),USE(?OptionsReset)
         END
         MENU('&Help'),USE(?MenuHelp),LAST
           ITEM('&Contents'),USE(?HelpContents),STD(STD:HelpIndex)
           ITEM('&Search for help on...'),USE(?HelpSearch),STD(STD:HelpSearch)
           ITEM('&How to use help'),USE(?HelpHow),STD(STD:HelpOnHelp)
           ITEM,SEPARATOR
           ITEM('&About'),USE(?HelpAbout)
         END
       END
       PANEL,AT(0,0,,2),USE(?PanelTop),FULL,BEVEL(0,0,0600H)
       BUTTON,AT(1,1,18,16),USE(?ButtNew),SKIP,TIP('Create new compile list'),ICON('NEW.ico')
       BUTTON,AT(19,1,18,16),USE(?ButtOpen),SKIP,TIP('Open existing compile list'),ICON('OPEN.ico')
       BUTTON,AT(39,1,18,16),USE(?ButtIns),SKIP,DISABLE,TIP('Insert new app/prj into compile list'),ICON('INS.ico')
       BUTTON,AT(57,1,18,16),USE(?ButtDel),SKIP,DISABLE,TIP('Delete item from compile list'),ICON('DEL.ico')
       BUTTON,AT(77,1,18,16),USE(?ButtMoveUp),SKIP,DISABLE,TIP('Move item up in compile list'),ICON('MOVEU.ico')
       BUTTON,AT(95,1,18,16),USE(?ButtMoveDown),SKIP,DISABLE,TIP('Move item down in compile list'),ICON('MOVED.ico')
       BUTTON,AT(115,1,18,16),USE(?ButtCompileOne),SKIP,DISABLE,TIP('Compile selected items'),ICON('COMONE.ico')
       BUTTON,AT(133,1,18,16),USE(?ButtCompileAll),SKIP,DISABLE,TIP('Compile all items'),ICON('COMALL.ico')
       PANEL,AT(37,1,1,16),USE(?PanelV1),BEVEL(0,0,06000H)
       PANEL,AT(75,1,1,16),USE(?PanelV2),BEVEL(0,0,06000H)
       PANEL,AT(113,1,1,16),USE(?PanelV3),BEVEL(0,0,06000H)
       PANEL,AT(0,16,,2),USE(?PanelBottom),FULL,BEVEL(0,0,09H)
       LIST,AT(2,3,150,95),USE(?List),DISABLE,HVSCROLL,LEFT,FONT('MS Sans Serif',8,,),MSG('Browsing Records'), |
           ALRT(CtrlSpace),ALRT(MouseLeft),ALRT(SpaceKey),FORMAT('43L(2)|MI~Application~@s64@77L(2)|M~Latest exe/dll/lib~@s30@20L(2)~Path~@s64@'), |
           MARK(self.qProgs.bMark),FROM(self.qProgs)
     END

cWarn gjsWarnClass

csTmpFile cstring(FILE:MaxFilePath)

i ushort

  code
  self.cCompile.sStartPath = path()

  cWarn.DoShow('New in Version ' & eCMVer & '.<13,10>' & |
               'Bug fixed:  Windows 2000 tooltip gpf, compiled in Clarion 5.5.  ', |
               'cm2.ini', 'NewFeatures')

  cWarn.DoShow('When using new and beta versions of Clarion care must be taken with Compile Manager.  ' & |
               'This is because Clarion will automatically upgrade any .APP files sent to it, without warning!', |
               'cm2.ini', 'BetaWarn')

  open(window)

  loop i = ?ButtNew TO ?ButtCompileAll
    i{PROP:Flat} = True
  end

  self.ControlList = ?List
  self.ControlWindow &= window
  self.cCompile.ControlStop = ?ButtCompileOne
  self.cCompile.ControlSkip = ?ButtCompileAll

  window{PROP:MinWidth} = window{PROP:Width}
  window{PROP:MinHeight} = window{PROP:Height} / 2

  self.lOld.Width = window{PROP:Width}
  self.lOld.Height = window{PROP:Height}

  if getini('Previous', 'Maximize', window{PROP:Maximize}, 'cm2.ini')
    window{PROP:Maximize} = 1
    self.ResizeWindow()

  elsif getini('Previous', 'Iconize', window{PROP:Iconize}, 'cm2.ini')
    !|  Let window open in default size
  else
    setposition(0, getini('Previous', 'XPos', window{PROP:XPos}, 'cm2.ini'), |
                   getini('Previous', 'YPos', window{PROP:YPos}, 'cm2.ini'), |
                   getini('Previous', 'Width', window{PROP:Width}, 'cm2.ini'), |
                   getini('Previous', 'Height', window{PROP:Height}, 'cm2.ini'))
    self.ResizeWindow()
  end

  ?List{PROPLIST:Width, 1} = getini('Previous', 'ListCol1', ?List{PROP:Width} / 3, 'cm2.ini')
  ?List{PROPLIST:Width, 2} = getini('Previous', 'ListCol2', ?List{PROP:Width} / 3, 'cm2.ini')
  ?List{PROPLIST:Width, 3} = getini('Previous', 'ListCol3', ?List{PROP:Width} / 3, 'cm2.ini')

  self.bTool = getini('Previous', 'Show toolbar', 1, 'cm2.ini')
  do UpdateTool
  self.bTop = getini('Previous', 'On top', 1, 'cm2.ini')
  self.bResult = getini('Previous', 'Result', 1, 'cm2.ini')

  do LoadPrevious

  ?List{PROP:IconList, 1} = '~CHECK0.ICO'
  ?List{PROP:IconList, 2} = '~CHECK1.ICO'
  ?List{PROP:IconList, 3} = '~CHECK2.ICO'
  ?List{PROP:IconList, 4} = '~CHECK3.ICO'
  ?List{PROP:LineHeight} = 9

  select(?List, 1)

  accept
    case event()
    of EVENT:OpenWindow
      do UpdateTop
      sCurrentPrj = command('')
      if sCurrentPrj = ''
        sCurrentPrj = getini('Previous', 'File name', '', 'cm2.ini')
      end
      if sCurrentPrj ~= ''
        do OpenFile
      else
        clear(sCurrentPrj)
      end

    of EVENT:CloseWindow
      putini('Previous', 'File name', sCurrentPrj, 'cm2.ini')
      compile('***', eDemoMode)
      self.DemoMessage
      !***

    of EVENT:Timer

    of EVENT:Sized
    orof EVENT:Maximized
    orof EVENT:Restored
      self.ResizeWindow()
    end

    case field()
    of ?FileNew orof ?ButtNew
      case event()
      of EVENT:Accepted
        clear(self.sTmpFile)
        if filedialog('Create Compile Manager Project', self.sTmpFile, 'Compile Manager|*.cm2', FILE:LongName + FILE:Save)
          self.cComFile.Init(self.sTmpFile)
          if self.cComFile.sExt = ''
            self.cComFile.sPath = CLIP(self.cComFile.sPath) & '.cm2'
            self.cComFile.sExt = '.cm2'
          end
          if lower(self.cComFile.sExt) ~= '.cm2'
            message('Invalid file extension!', 'Error', ICON:Exclamation)
            message(self.cComFile.sPath, self.cComFile.sExt)
          else
            sCurrentPrj = self.cComFile.sPath
            close(fCompile)
            sCompile = clip(sCurrentPrj) & '\!fCompile'
            create(fCompile)
            assert(~errorcode())

            close(fOptions)
            sOptions = clip(sCurrentPrj) & '\!fOptions'
            create(fOptions)
            assert(~errorcode())

            do OpenFile
          end
        end
      end

    of ?FileOpen orof ?ButtOpen
      case event()
      of EVENT:Accepted
        clear(self.sTmpFile)
        if filedialog('Open Compile Manager Project', self.sTmpFile, 'Compile Manager|*.cm2', FILE:LongName)
          sCurrentPrj = self.sTmpFile
          close(fCompile)
          close(fOptions)
          do OpenFile
        end
      end

    of ?FileImport
      case event()
      of EVENT:Accepted
        clear(self.sTmpFile)
        if filedialog('Import .CCL File', self.sTmpFile, 'Clarion Compile List|*.ccl', FILE:LongName)
          self.ImportCCL()
        end
      end

    of ?FileClose
      case event()
      of EVENT:Accepted
        clear(self.sTmpFile)
        clear(sCurrentPrj)
        free(self.qProgs)
        ?MenuEdit{PROP:Disable} = True
        ?MenuCompile{PROP:Disable} = True
        disable(?ButtIns, ?List)
        ?FileClose{PROP:Disable} = True
        ?FileImport{PROP:Disable} = True
        ?FileProperties{PROP:Disable} = True
        window{PROP:Text} = eTitle
      end

    of ?FileProperties
      case event()
      of EVENT:Accepted
        self.DisplayOptions()
      end

    of ?bTool
      case event()
      of EVENT:Accepted
        do UpdateTool
      end

    of ?bTop
      case event()
      of EVENT:Accepted
        do UpdateTop
      end

    of ?bResult
      case event()
      of EVENT:Accepted
        do UpdateResult
      end

!    of ?OptionCompile
!      case event()
!      of EVENT:Accepted
!        self.DisplayCompile()
!      end

    of ?OptionSound
      case event()
      of EVENT:Accepted
        self.DisplaySounds()
      end

    of ?OptionsReset
      case event()
      of EVENT:Accepted
        if GetWindowsDirectory(csTmpFile, FILE:MaxFilePATH)
          sFileIn = clip(csTmpFile & '\CM2.INI')
          remove(TmpFileIn)
          assert(~errorcode())
          do LoadPrevious
        end
      end

    of ?FilePrevious1
      case event()
      of EVENT:Accepted
        self.sTmpFile = getini('Previous', 'File1', , 'cm2.ini')
        do GetPrevious
      end

    of ?FilePrevious2
      case event()
      of EVENT:Accepted
        self.sTmpFile = getini('Previous', 'File2', , 'cm2.ini')
        do GetPrevious
      end

    of ?FilePrevious3
      case event()
      of EVENT:Accepted
        self.sTmpFile = getini('Previous', 'File3', , 'cm2.ini')
        do GetPrevious
      end

    of ?FilePrevious4
      case event()
      of EVENT:Accepted
        self.sTmpFile = getini('Previous', 'File4', , 'cm2.ini')
        do GetPrevious
      end

    of ?FileExit
      case event()
      of EVENT:Accepted
        post(EVENT:CloseWindow)
      end

    of ?EditIns orof ?ButtIns
      case event()
      of EVENT:Accepted
        clear(self.sTmpFile)
        if filedialog('Open clarion file', self.sTmpFile, |
                       'Clarion files|*.app;*.prj;*.pr|' & |
                       'All|*.*', FILE:LongName)
          set(COM:S)
          previous(fCOmpile)
          if errorcode()
            lHold# = 1
          else
            lHold# = COM:lSeqNo +1
          end
          COM:lSeqNo = lHold#
          COM:sPrjPath = self.sTmpFile
          add(fCompile)
          self.LoadQ()
        end
      end

    of ?EditDel orof ?ButtDel
      case event()
      of EVENT:Accepted
        loop self.i = 1 to records(self.qProgs)
          get(self.qProgs, self.i)
          if self.qProgs.bMark = 1
            assert(~errorcode())
            COM:lSeqNo = self.qProgs.lSeqNo
            get(fCompile, COM:S)
            assert(~errorcode())
            delete(fCompile)
            assert(~errorcode())
          end
        end
        self.LoadQ()
      end

    of ?List
      case event()
      of EVENT:PreAlertKey
        case keycode()
        of MouseLeft
        orof SpaceKey
          loop self.i = 1 to records(self.qProgs)
            get(self.qProgs, self.i)
            self.qProgs.bMark = 0
            put(self.qProgs)
          end
          cycle
        end

      of EVENT:AlertKey
        case keycode()
        of CtrlSpace
          self.lChoice = choice(?List)
          get(self.qProgs, self.lChoice)
          if self.qProgs.bMark = 0
            self.qProgs.bMark = 1
          else
            self.qProgs.bMark = 0
          end
          put(self.qProgs)
        end

      of EVENT:NewSelection
        self.lChoice = choice(?List)
        get(self.qProgs, self.lChoice)
        if band(keystate(), 0100h) = 0100h                  !|  Shift Select
          Start# = choose(self.lChoice < self.lOldChoice, self.lChoice, self.lOldChoice)
          Stop# = choose(self.lChoice > self.lOldChoice, self.lChoice, self.lOldChoice)
          loop self.i = 1 to records(self.qProgs)
            get(self.qProgs, self.i)
            if self.i >= Start# and self.i <= Stop#
              self.qProgs.bMark = 1
            else
              self.qProgs.bMark = 0
            end
            put(self.qProgs)
          end
        elsif band(keystate(), 0200h) = 0200h               !|  Ctrl Select
          self.lOldChoice = self.lChoice
        else                                                !|  Normal Select
!          loop self.i = 1 to records(self.qProgs)
!            get(self.qProgs, self.i)
!            if self.i = self.lChoice
!              self.qProgs.bMark = 1
!            else
!              self.qProgs.bMark = 0
!            end
!            put(self.qProgs)
!          end
          self.qProgs.bMark = 1
          put(self.qProgs)
          self.lOldChoice = self.lChoice
          display()
        end
      end

      do UpdateButtons

    of ?EditMoveUp orof ?ButtMoveUp
      case event()
      of EVENT:Accepted
        loop self.i = 1 to records(self.qProgs)
          get(self.qProgs, self.i)
          if self.qProgs.bMark = 1
            if self.SrcMoveLine(self.qProgs.lSeqNo, 1)
              ?List{PROP:Selected} = self.i - 1
              self.LoadQ()
              post(EVENT:NewSelection, ?List)
            end
            break
          end
        end
      end

    of ?EditMoveDown orof ?ButtMoveDown
      case event()
      of EVENT:Accepted
        loop self.i = 1 to records(self.qProgs)
          get(self.qProgs, self.i)
          if self.qProgs.bMark = 1
            if self.SrcMoveLine(self.qProgs.lSeqNo, 0)
              ?List{PROP:Selected} = self.i + 1
              self.LoadQ()
              post(EVENT:NewSelection, ?List)
            end
            break
          end
        end
      end

    of ?CompileOne orof ?ButtCompileOne
      case event()
      of EVENT:Accepted
        do ChangeIconStart
        cWarn.DoShow('It is striongly advised that you close all .APP and .PRJ files within Clarion prior to batch compiles.  ' & |
                     '', |
                     'cm2.ini', 'CompileWarn')
        loop self.i = 1 to records(self.qProgs)
          get(self.qProgs, self.i)
          assert(~errorcode())
          compile('***', eDemoMode)
          if self.i > 3
            self.DemoMessage
            break
          end
          !***
          if self.qProgs.bMark
            self.TheCompile()
          end
        end
        do ChangeIconStop
      end

    of ?CompileAll orof ?ButtCompileAll
      case event()
      of EVENT:Accepted
        do ChangeIconStart
        cWarn.DoShow('It is striongly advised that you close all .APP and .PRJ files within Clarion prior to batch compiles.  ' & |
                     '', |
                     'cm2.ini', 'CompileWarn')
        loop self.i = 1 to records(self.qProgs)
          get(self.qProgs, self.i)
          assert(~errorcode())
          compile('***', eDemoMode)
          if self.i > 3
            self.DemoMessage
            break
          end
          !***
          self.TheCompile()
        end
        do ChangeIconStop
      end

    of ?HelpAbout
      case event()
      of EVENT:Accepted
        compile('***', eDemoMode)
        self.cAbout.Display('Clarion Compile Manager (Demo)', eCMVer, '~a.ICO')
        !***
        omit('***', eDemoMode)
        self.cAbout.Display('Clarion Compile Manager', eCMVer, '~a.ICO')
        !***
      end

    end
!    get(self.qProgs, 1)
!    target{prop:text} = self.qProgs.bMark
  end

  putini('Previous', 'Maximize', window{PROP:Maximize}, 'cm2.ini')
  putini('Previous', 'Iconize', window{PROP:Iconize}, 'cm2.ini')
  putini('Previous', 'XPos', window{PROP:XPos}, 'cm2.ini')
  putini('Previous', 'YPos', window{PROP:YPos}, 'cm2.ini')
  putini('Previous', 'Width', window{PROP:Width}, 'cm2.ini')
  putini('Previous', 'Height', window{PROP:Height}, 'cm2.ini')
  putini('Previous', 'Show toolbar', self.bTool, 'cm2.ini')
  putini('Previous', 'On top', self.bTop, 'cm2.ini')
  putini('Previous', 'Result', self.bResult, 'cm2.ini')
  putini('Previous', 'ListCol1', ?List{PROPLIST:Width, 1}, 'cm2.ini')
  putini('Previous', 'ListCol2', ?List{PROPLIST:Width, 2}, 'cm2.ini')
  putini('Previous', 'ListCol3', ?List{PROPLIST:Width, 3}, 'cm2.ini')
  close(Window)

ChangeIconStart             routine
  ?List{PROP:Color} = COLOR:BtnFace
  disable(?MenuFile, ?HelpAbout)
  disable(?ButtNew, ?ButtMoveDown)
  enable(self.cCompile.ControlStop)
  enable(self.cCompile.ControlSkip)
  self.cCompile.ControlStop{PROP:Icon} = '~stop.ico'
  self.cCompile.ControlStop{PROP:ToolTip} = 'Stop Batch Compile'
  self.cCompile.ControlSkip{PROP:Icon} = '~skip.ico'
  self.cCompile.ControlSkip{PROP:ToolTip} = 'Skip Batch Compile'
  display()

ChangeIconStop              routine
  ?List{PROP:Color} = COLOR:Window
  self.cCompile.ControlStop{PROP:Icon} = '~ComOne.ico'
  self.cCompile.ControlStop{PROP:ToolTip} = 'Compile selected items'
  self.cCompile.ControlSkip{PROP:Icon} = '~ComAll.ico'
  self.cCompile.ControlSkip{PROP:ToolTip} = 'Compile all items'
  enable(?MenuFile, ?HelpAbout)
  enable(?ButtNew, ?ButtMoveDown)
  do UpdateButtons
  display()
  self.PlaySound()

UpdateTool                  routine
  if self.bTool
    setposition(?List, , 20, Window{PROP:Width} - 4, Window{PROP:Height} - 4 - 18)
    unhide(?PanelTop, ?PanelBottom)
  else
    hide(?PanelTop, ?PanelBottom)
    setposition(?List, , 2, Window{PROP:Width} - 4, Window{PROP:Height} - 4)
  end

UpdateTop                   routine
  if self.bTop
    if SetWindowPos(Window{Prop:Handle}, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE + SWP_NOMOVE + SWP_NOSIZE).
  else
    if SetWindowPos(Window{Prop:Handle}, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE + SWP_NOMOVE + SWP_NOSIZE).
  end
  SetForegroundwindow(Window{Prop:Handle})

UpdateResult                routine
  data
i                           ushort
  code
  if self.bResult = False
    loop i = 1 to records(self.qProgs)
      get(self.qProgs, i)
      self.qProgs.lIResult = 1
      put(self.qProgs)
    end
    display(?List)
  end


OpenFile                    routine
  sCompile = clip(sCurrentPrj) & '\!fCompile'
  open(fCompile)
  if errorcode()
    message('Invalid Compile File', 'Error', ICON:Exclamation)
    clear(sCurrentPrj)
  else
    sOptions = clip(sCurrentPrj) & '\!fOptions'
    open(fOptions)
    if errorcode()
      message('Invalid Compile File', 'Error', ICON:Exclamation)
    else
      window{PROP:Text} ='[' & CLIP(sCurrentPrj) & ']  ' &  eTitle
      ?MenuEdit{PROP:Disable} = False
      ?MenuCompile{PROP:Disable} = False
      ?FileClose{PROP:Disable} = False
      ?FileImport{PROP:Disable} = False
      ?FileProperties{PROP:Disable} = False
      enable(?ButtIns, ?List)
      do SetPrevious

      COP:lSeqNo = 1
      get(fOptions, COP:S)
      if errorcode()
        self.DisplayOptions()
      end
      self.LoadQ()
    end
  end

LoadPrevious                routine
  ?FilePrevious1{PROP:Text} = '&1 ' & getini('Previous', 'File1', '', 'cm2.ini')
  ?FilePrevious1{PROP:Disable} = choose(?FilePrevious1{PROP:Text} = '&1', True, False)
  ?FilePrevious2{PROP:Text} = '&2 ' & getini('Previous', 'File2', '', 'cm2.ini')
  ?FilePrevious2{PROP:Disable} = choose(?FilePrevious2{PROP:Text} = '&2', True, False)
  ?FilePrevious3{PROP:Text} = '&3 ' & getini('Previous', 'File3', '', 'cm2.ini')
  ?FilePrevious3{PROP:Disable} = choose(?FilePrevious3{PROP:Text} = '&3', True, False)
  ?FilePrevious4{PROP:Text} = '&4 ' & getini('Previous', 'File4', '', 'cm2.ini')
  ?FilePrevious4{PROP:Disable} = choose(?FilePrevious4{PROP:Text} = '&4', True, False)

SetPrevious                 routine
  data
i                           long
j                           long
sPreviousFile               string(FILE:MaxFilePATH)
  code
  loop i = 1 to 4
    if upper(getini('Previous', 'File' & format(i, @n1), , 'cm2.ini')) = upper(sCurrentPrj)
      break
    end
  end
  loop j = i - 1 to 1 by -1
    sPreviousFile = getini('Previous', 'File' & format(j, @n1), , 'cm2.ini')
    putini('Previous', 'File' & format(j + 1, @n1), lower(sPreviousFile), 'cm2.ini')
  end
  putini('Previous', 'File1', lower(sCurrentPrj), 'cm2.ini')
  do LoadPrevious

GetPrevious                 routine
  data
csTmpFile                   cstring(FILE:MaxFilePATH)
  code
  csTmpFile = self.sTmpFile
  if ~Access(csTmpFile, 0) 
    close(fCompile)
    close(fOptions)
    sCurrentPrj = self.sTmpFile
    do OpenFile
  else
    message('Unable to open previous file.  ' & error(), 'Error', ICON:Exclamation)
  end

UpdateButtons               routine
  data
lCount                      long
  code
  loop self.i = 1 to records(self.qProgs)
    get(self.qProgs, self.i)
    if self.qProgs.bMark
      lCOunt += 1
    end
  end
  case lCount
  of 0
    disable(?CompileOne)
    disable(?ButtCompileOne)
    disable(?EditDel)
    disable(?ButtDel)
    disable(?EditMoveUp)
    disable(?ButtMoveUp)
    disable(?EditMoveDown)
    disable(?ButtMoveDown)
  of 1
    enable(?CompileOne)
    enable(?ButtCompileOne)
    enable(?EditDel)
    enable(?ButtDel)
    enable(?EditMoveUp)
    enable(?ButtMoveUp)
    enable(?EditMoveDown)
    enable(?ButtMoveDown)
  else
    enable(?CompileOne)
    enable(?ButtCompileOne)
    enable(?EditDel)
    enable(?ButtDel)
    disable(?EditMoveUp)
    disable(?ButtMoveUp)
    disable(?EditMoveDown)
    disable(?ButtMoveDown)
  end

cmMainClass.SrcMoveLine     function(long lSeqNo, byte bDir)

lNo1                LONG
lNo2                LONG
bReturn             BYTE

  code
  bReturn = 0
  logout(1, fCompile)
  COM:lSeqNo = lSeqNo
  get(fCompile, COM:S)
  assert(~errorcode())
  lNo1 = COM:lSeqNo
  set(COM:S, COM:S)
  if bDir
    previous(fCompile)
    previous(fCompile)
  else
    next(fCompile)
    next(fCompile)
  end
  if errorcode()
    beep
  else
    lNo2 = COM:lSeqNo
    clear(COM:lSeqNo, 1)
    put(fCompile)
    if errorcode()
      beep
      rollback
    else
      COM:lSeqNo = lNo1
      get(fCompile, COM:S)
      if errorcode()
        beep
        rollback
      else
        COM:lSeqNo = lNo2
        put(fCompile)
        if errorcode()
          beep
          rollback
        else
          clear(COM:lSeqNo, 1)
          get(fCompile, COM:S)
          if errorcode()
            beep
            rollback
          else
            COM:lSeqNo = lNo1
            put(fCompile)
            if errorcode()
              beep
              rollback
            else
              commit
              bReturn = 1
            end
          end
        end
      end
    end
  end
  return(bReturn)

cmMainClass.DisplayOptions  procedure()

window WINDOW('Properties'),AT(,,300,114),FONT('MS Sans Serif',8,,FONT:regular),CENTER,HLP('~WinProp'), |
         SYSTEM,GRAY,DOUBLE
       PROMPT('CW Folder'),AT(5,11)
       ENTRY(@s255),AT(68,10,210,12),USE(COP:sRoot)
       BUTTON('...'),AT(283,10,12,12),USE(?ButtLkupRoot)
       PROMPT('CW Redirection file:'),AT(5,26)
       ENTRY(@s255),AT(68,25,210,12),USE(COP:sRedPath)
       BUTTON('...'),AT(283,25,12,12),USE(?ButtLkupRed)
       PROMPT('CW Executable file:'),AT(5,41)
       ENTRY(@s255),AT(68,40,210,12),USE(COP:sCwPath)
       BUTTON('...'),AT(283,40,12,12),USE(?ButtLkupCw)
       CHECK('Copy compiled programs to new directory'),AT(5,66),USE(COP:bCopyToFlag)
       PROMPT('Copy to Folder:'),AT(5,81),USE(?PromptCopyTo)
       ENTRY(@s255),AT(68,80,210,12),USE(COP:sCopyToPath)
       BUTTON('...'),AT(283,80,12,12),USE(?ButtLkupCopyTo)
       BUTTON('&Ok'),AT(205,96,45,15),USE(?ButtOK)
       BUTTON('&Cancel'),AT(250,96,45,15),USE(?ButtCancel)
     END

csTmpFile                   cstring(FILE:MaxFilePATH)
bAddFlag                    byte

  code

  open(window)

  COP:lSeqNo = 1
  get(fOptions, COP:S)
  if errorcode()
    bAddFlag = 1
    COP:sRoot = getini('Options', 'Root', 'c:\clarion4', 'cm2.ini')
    COP:sRedPath = getini('Options', 'RED File', 'c:\clarion4\bin\clarion4.red', 'cm2.ini')
    COP:sCwPath = getini('Options', 'EXE File', 'c:\clarion4\bin\clarion4.exe', 'cm2.ini')
    COP:bCopyToFlag = getini('Options', 'Copy to flag', 0, 'cm2.ini')
    COP:sCopyToPath = getini('Options', 'Copy to path', '', 'cm2.ini')
    disable(?ButtCancel)
  else
    bAddFlag = 0
  end

  do UpdateCopyTo

  accept
    case field()
    of ?ButtLkupRoot
      case event()
      of EVENT:Accepted
        if filedialog('Locate Clarion Root Folder', COP:sRoot, 'CW Redirection|*.red', FILE:LongName + FILE:Directory)
          display(?COP:sRoot)
        end
      end
    of ?ButtLkupRed
      case event()
      of EVENT:Accepted
        if filedialog('Locate Clarion Redirection File', COP:sRedPath, 'CW Redirection|*.red', FILE:LongName)
          display(?COP:sRedPath)
        end
      end
    of ?ButtLkupCw
      case event()
      of EVENT:Accepted
        if filedialog('Locate Clarion Executable File', COP:sCwPath, 'CW Executable|*.exe', FILE:LongName)
          display(?COP:sCwPath)
        end
      end
    of ?COP:bCopyToFlag
      case event()
      of EVENT:Accepted
        do UpdateCopyTo
      end
    of ?ButtLkupCopyTo
      case event()
      of EVENT:Accepted
        if filedialog('Locate destination folder', COP:sCopyToPath, 'Folders|*.', FILE:LongName + FILE:Directory)
          display(?COP:sCopyToPath)
        end
      end

    of ?ButtOK
      case event()
      of EVENT:Accepted

        if COP:sRoot[len(clip(COP:sRoot))] = '\'
          COP:sRoot = COP:sRoot[1 : len(clip(COP:sRoot)) - 1]
        end
        csTmpFile = clip(COP:sRoot)
        if Access(csTmpFile, 0)
          beep
          select(?COP:sRoot)
          cycle
        end
        COP:sRoot = clip(COP:sRoot) & '\'

        if COP:sRedPath[len(clip(COP:sRedPath))] = '\'
          COP:sRedPath = COP:sRedPath[1 : len(clip(COP:sRedPath)) - 1]
        end
        csTmpFile = clip(COP:sRedPath)
        if Access(csTmpFile, 0)
          beep
          select(?COP:sRedPath)
          cycle
        end

        if COP:sCWPath[len(clip(COP:sCWPath))] = '\'
          COP:sCWPath = COP:sCWPath[1 : len(clip(COP:sCWPath)) - 1]
        end
        csTmpFile = clip(COP:sCWPath)
        if Access(csTmpFile, 0)
          beep
          select(?COP:sCWPath)
          cycle
        end

        if COP:bCopyToFlag
          if ~exists(clip(COP:sCopyToPath))
            COP:sCopyToPath = 'test'
            beep
            select(?COP:sCopyToPath)
            cycle
          end
        end

        putini('Options', 'Root', COP:sRoot, 'cm2.ini')
        putini('Options', 'RED File', COP:sRedPath, 'cm2.ini')
        putini('Options', 'EXE File', COP:sCwPath, 'cm2.ini')
        putini('Options', 'Copy to flag', COP:bCopyToFlag, 'cm2.ini')
        putini('Options', 'Copy to path', COP:sCopyToPath, 'cm2.ini')
        COP:lSeqNo = 1
        if bAddFlag
          add(fOptions)
        else
          put(fOptions)
        end
        post(EVENT:CloseWindow)
      end
    of ?ButtCancel
      case event()
      of EVENT:Accepted
        post(EVENT:CloseWindow)
      end
    end
  end
  close(window)

UpdateCopyTo                routine

  if COP:bCopyToFlag = 1
    ?PromptCopyTo{PROP:Disable} = False
    ?COP:sCopyToPath{PROP:Disable} = False
    ?COP:sCopyToPath{PROP:Color} = COLOR:None
    ?ButtLkupCopyTo{PROP:Disable} = False
  else
    ?PromptCopyTo{PROP:Disable} = True
    ?COP:sCopyToPath{PROP:Disable} = True
    ?COP:sCopyToPath{PROP:Color} = COLOR:BtnFace
    ?ButtLkupCopyTo{PROP:Disable} = True
  end

cmMainClass.DisplayCompile  procedure()

OptionDebug                 string(1)
OptionCompile               string(1)

window WINDOW('Compile Options'),AT(,,230,90),FONT('MS Sans Serif',8,,FONT:regular),CENTER,HLP('~WinProp'), |
         SYSTEM,GRAY,DOUBLE
       OPTION('Debug Mode'),AT(10,5,100,60),USE(OptionDebug),BOXED
         RADIO('Default'),AT(20,20),USE(?OptionDebug1),VALUE('1')
         RADIO('Convert to "No debug"'),AT(20,35),USE(?OptionDebug2),VALUE('2')
         RADIO('Convert to "Full Debug"'),AT(20,50),USE(?OptionDebug3),VALUE('3')
       END
       OPTION('Compile Mode'),AT(120,5,100,60),USE(OptionCompile),BOXED
         RADIO('Default'),AT(130,20),USE(?OptionCompile1),VALUE('1')
         RADIO('Convert to "16bit"'),AT(130,35),USE(?OptionCompile2),VALUE('2')
         RADIO('Convert to "32bit"'),AT(130,50),USE(?OptionCompile3),VALUE('3')
       END
       BUTTON('&Ok'),AT(130,72,45,15),USE(?ButtOK)
       BUTTON('&Cancel'),AT(175,72,45,15),USE(?ButtCancel)
     END

  code

  OptionDebug = getini('Compile', 'Debug', '1', 'cm2.ini')
  OptionCompile = getini('Compile', 'Mode', '1', 'cm2.ini')

  open(window)
  accept
    case event()
    of EVENT:Rejected
      beep
      select(?)
    end
    case field()
    of ?OptionDebug
      case event()
      of EVENT:Accepted
      end
    of ?OptionCompile
      case event()
      of EVENT:Accepted
      end
    of ?ButtOK
      case event()
      of EVENT:Accepted
        putini('Compile', 'Debug', OptionDebug, 'cm2.ini')
        putini('Compile', 'Mode', OptionCompile, 'cm2.ini')
        post(EVENT:CloseWindow)
      end
    of ?ButtCancel
      case event()
      of EVENT:Accepted
        post(EVENT:CloseWindow)
      end
    end
  end
  close(window)

cmMainClass.DisplaySounds   procedure()

OptionSound                 string(1)
lNoBeeps                    long
lBeepGap                    long
sSoundFile                  string(FILE:MaxFilePath)

window WINDOW('Sound Options'),AT(,,300,91),FONT('MS Sans Serif',8,,FONT:regular),CENTER,HLP('~WinProp'), |
         SYSTEM,GRAY,DOUBLE
       OPTION('After compiling'),AT(5,5,290,65),USE(OptionSound),BOXED
         RADIO('No Sound'),AT(15,20),VALUE('1')
         RADIO('Beep'),AT(15,35),VALUE('2')
         RADIO('Play .WAV file'),AT(15,50),VALUE('3')
       END
       PROMPT('Number of beeps:'),AT(78,35),USE(?PromptNoBeeps)
       SPIN(@n1),AT(137,34,22,12),USE(lNoBeeps),RANGE(1,9),STEP(1)
       PROMPT('Gap:'),AT(165,35),USE(?PromptGap)
       SPIN(@n3),AT(187,34,22,12),USE(lBeepGap),RANGE(1,999),STEP(1)
       STRING('hundredths of a second'),AT(216,35),USE(?PromptUnits)
       ENTRY(@s244),AT(78,49,195,12),USE(sSoundFile)
       BUTTON('...'),AT(278,49,12,12),USE(?ButtSoundFile)
       BUTTON('&Sample'),AT(5,73,45,15),USE(?ButtSample)
       BUTTON('&Ok'),AT(205,74,45,15),USE(?ButtOK)
       BUTTON('&Cancel'),AT(250,74,45,15),USE(?ButtCancel)
     END

lTime                       long
csTmpFile                   cstring(FILE:MaxFilePath)
csSoundFile                 cstring(FILE:MaxFilePath + 1)

  code

  OptionSound = getini('Sound', 'Option', '1', 'cm2.ini')
  lNoBeeps = getini('Sound', 'NoBeeps', 1, 'cm2.ini')
  lBeepGap = getini('Sound', 'BeepGap', 10, 'cm2.ini')
  sSoundFile = getini('Sound', 'SoundFile', '', 'cm2.ini')

  open(window)

  do UpdateControls

  accept
    case event()
    of EVENT:Rejected
      beep
      select(?)
    end
    case field()
    of ?OptionSound
      case event()
      of EVENT:Accepted
        do UpdateControls
      end
    of ?ButtSoundFile
      case event()
      of EVENT:Accepted
        if filedialog('Open sound file', sSoundFile, 'WAV File|*.wav', FILE:LongName)
          display(?sSoundFile)
        end
      end
    of ?ButtSample
      case event()
      of EVENT:Accepted
        case OptionSound
        of '1'
        of '2'
          setcursor(CURSOR:Wait)
          loop lNoBeeps times
            beep
            lTime = clock()
            loop; yield
              if lTime + lBeepGap <= clock()
                break
              end
            end
          end
          setcursor()
        of '3'
          csSoundFile = clip(sSoundFile)
          sndPlaySound(csSoundFile, 1)
        end
      end
    of ?ButtOK
      case event()
      of EVENT:Accepted
        case OptionSound
        of '2'
          if lNoBeeps < 1 or lNoBeeps > 9
            beep
            select(?lNoBeeps)
            cycle
          end
        of '3'
          csTmpFile = sSoundFile
          if Access(csTmpFile, 0)
            beep
            select(?sSoundFile)
            cycle
          end
        end
        putini('Sound', 'Option', OptionSound, 'cm2.ini')
        putini('Sound', 'NoBeeps', lNoBeeps, 'cm2.ini')
        putini('Sound', 'BeepGap', lBeepGap, 'cm2.ini')
        putini('Sound', 'SoundFile', sSoundFile, 'cm2.ini')
        post(EVENT:CloseWindow)
      end
    of ?ButtCancel
      case event()
      of EVENT:Accepted
        post(EVENT:CloseWindow)
      end
    end
  end
  close(window)

UpdateControls              routine

  case(OptionSound)
  of '1'
    hide(?PromptNoBeeps)
    hide(?lNoBeeps)
    hide(?PromptGap)
    hide(?lBeepGap)
    hide(?PromptUnits)
    hide(?sSoundFile)
    hide(?ButtSoundFile)
  of '2'
    unhide(?PromptNoBeeps)
    unhide(?lNoBeeps)
    unhide(?PromptGap)
    unhide(?lBeepGap)
    unhide(?PromptUnits)
    hide(?sSoundFile)
    hide(?ButtSoundFile)
  of '3'
    hide(?PromptNoBeeps)
    hide(?lNoBeeps)
    hide(?PromptGap)
    hide(?lBeepGap)
    hide(?PromptUnits)
    unhide(?sSoundFile)
    unhide(?ButtSoundFile)
  end
  display()

cmMainClass.PlaySound       procedure()

OptionSound                 string(1)
lNoBeeps                    long
lBeepGap                    long
csSoundFile                 cstring(FILE:MaxFilePath + 1)

lTime                       long

  code

  OptionSound = getini('Sound', 'Option', '1', 'cm2.ini')
  lNoBeeps = getini('Sound', 'NoBeeps', 1, 'cm2.ini')
  lBeepGap = getini('Sound', 'BeepGap', 100, 'cm2.ini')
  csSoundFile = getini('Sound', 'SoundFile', '', 'cm2.ini')

  case OptionSound
  of '1'
  of '2'
    loop lNoBeeps times
      beep
      lTime = clock()
      loop; yield
        if lTime + lBeepGap <= clock()
          break
        end
      end
    end
  of '3'
    sndPlaySound(csSoundFile, 1)
  end

cmMainClass.TheCompile      procedure()

sTitle                      string(64)

  code
  sTitle = target{PROP:Text}
  clear(self.gResult)
  self.ControlList{PROP:Selected} = self.i
  target{PROP:Text} = self.qProgs.sName
  self.cCompile.bShowResult = self.bResult
  case self.cCompile.DoCompile(clip(self.qProgs.sPath), self.gResult, COP:sRedPath, COP:sCWPath, COP:sRoot)
  of 0
    self.qProgs.sResult = 'Cancelled'
    self.qProgs.lIResult = 1
    put(self.qProgs)
    self.i = records(self.qProgs)
  of 1
    self.PutStatus()
    self.qProgs.lIResult = 3
    put(self.qProgs)
  of 2
    self.qProgs.sResult = 'Skipped'
    self.qProgs.lIResult = 1
    put(self.qProgs)
  of 3
    self.PutStatus()
    self.qProgs.lIResult = 2
    put(self.qProgs)
  of 4
    self.PutStatus()
    self.qProgs.lIResult = 1
    put(self.qProgs)
  end
  target{PROP:Text} = sTitle
  display(self.ControlList)

cmMainClass.ResizeWindow    procedure()

  code
  self.lNew.Width = self.ControlWindow{PROP:Width}
  self.lNew.Height = self.ControlWindow{PROP:Height}
  self.lDelta.Width = (self.lNew.Width - self.lOld.Width)
  self.lDelta.Height = (self.lNew.Height - self.lOld.Height)
  setposition(self.ControlList, , , self.ControlList{PROP:Width} + self.lDelta.Width, self.ControlList{PROP:Height} + self.lDelta.Height)
  self.lOld.Width = self.lNew.Width
  self.lOld.Height = self.lNew.Height

cmMainClass.LoadQ           procedure()

lCount                      long

  code
  setcursor(CURSOR:Wait)
  free(self.qProgs)
  lCount = 1
  set(COM:S)
  loop
    next(fCompile)
    if errorcode()
      break
    end
    self.cComFile.Init(COM:sPrjPath)
    clear(self.qProgs)
    self.qProgs.sName = clip(self.cComFile.sName) & clip(self.cComFile.sExt)
    self.qProgs.sPath = clip(self.cComFile.sPath) 
    self.qProgs.lIResult = 1
    self.qProgs.sResult = '???'
    self.qProgs.lSeqNo = COM:lSeqNo
    if choice(self.ControlList) = lCount
      self.qProgs.bMark = 1
    else
      self.qProgs.bMark = 0
    end
    add(self.qProgs)
    self.PutStatus()
    lCount += 1
  end
  setcursor()
  display(self.ControlList)

cmMainClass.PutStatus       procedure()

cRed                        gjsRedClass
cFile                       gjsFileClass

  code
  cFile.Init(self.qProgs.sPath)
  if cRed.DoLoadQ(COP:sRedPath,clip(cFile.sDrive) & clip(cFile.sDir),COP:sRoot)
    self.qProgs.sResult = clip(cRed.GetFinalResult(self.qProgs.sPath))
    put(self.qProgs)
  end

cmMainClass.ImportCCL       procedure()

lSeqNo                      long

  code
  sFileCCL = self.sTmpFile
  open(fCCL)
  if errorcode()
    message('Error opening ' & clip(self.sTmpFile) & ' file', 'Error', ICON:Exclamation)
  else
    set(COM:S)
    previous(fCOmpile)
    if errorcode()
      lSeqNo = 1
    else
      lSeqNo = COM:lSeqNo +1
    end
    set(CCL:S)
    loop
      next(fCCL)
      if errorcode()
        break
      end
      COM:lSeqNo = lSeqNo
      COM:sPrjPath = CCL:sPrjPath
      add(fCompile)
      lSeqNo += 1
    end
    self.LoadQ()
  end
  close(fCCL)

  compile('***', eDemoMode)
cmMainClass.DemoMessage     procedure()

WinShare WINDOW(eTitle),AT(,,200,134),FONT('MS Sans Serif',8,,FONT:regular),CENTER,GRAY,DOUBLE
       PROMPT('Thank you for trying Compile Manager 2.<13,10,13,10>This crippled version is intended as ' &|
           'a "try before you buy" demo, which may be ditributed freely. <13,10>If you wish to pu' &|
           'rchase the full version please contact:<13,10,13,10>    Gordon Smith:<9>schmoo@iol.ie <13,10,9,9>w' &|
           'ww.iol.ie/~schmoo<13,10>    TopSpeed:<9>www.topspeed.com<13,10,13,10>The crippled version allows' &|
           ' a maximum of three compiles before displaying this window.'),AT(10,10,180,103),USE(?Prompt)
       BUTTON('OK'),AT(150,117,45,14),USE(?ButtOk)
     END

  code
  open(WinShare)
!  ?Prompt{PROP:Text} = 'Thank you for trying Compile Manager 2.<13><10><13><10>' & |
!                       'This crippled version is intended as a "try before you buy" demo, ' & |
!                       'which may be ditributed freely. <13><10>' & |
!                       'If you wish to purchase the full version please contact:<13><10><13><10>' & |
!                       '    Gordon Smith:<9>schmoo@iol.ie <13><10>' & |
!                       '<9><9>www.iol.ie/~schmoo<13><10>' & |
!                       '    TopSpeed:<9>www.topspeed.com<13><10><13><10>' & |
!                       'The crippled version allows two compiles before ' & |
!                       'this window is displayed.'
  accept
    case field()
    of ?ButtOK
      case event()
      of EVENT:Accepted
        break
      end
    end
  end
  close(WinShare)

  !***
